﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class GameController : MonoBehaviour {
	public GameObject[] characters;
	public GameObject gearPrefab;
	public Text textScore;

	public Transform startPosition;

	public float gearDistance;

	public float randomScaleMin;
	public float randomScaleMax;

	public Vector2 randomPosMin;
	public Vector2 randomPosMax;


	public GameObject gameOverPanel;
	public GameObject startPanel;

	int score;
	bool isGamePlaying;

	public float gearStartRotationSpeed;
	public float gearRotationInc;


	// Use this for initialization
	void Start () {

		SpawnGears ();
		Time.timeScale = 0;
		isGamePlaying = false;

	}
	
	// Update is called once per frame
	void Update () {

		// Spawn Gears:


		// Game Over:
		if (characters[0] == null
			&& characters[1] == null
			&& characters[2] == null) {
			DoGameOver ();

		}

	}

	public void SpawnGears() {
		float newX = 0;
		float newY = 0;
		newX = startPosition.position.x;
		for (int i = 1; i <= 100; i++) {
			newY = startPosition.position.y + Random.Range (randomPosMin.y, randomPosMax.y);

			GameObject gear = (GameObject)Instantiate (gearPrefab, new Vector3(newX,newY,0), Quaternion.identity);
			float randomScale = Random.Range (randomScaleMin, randomScaleMax);
			gear.transform.localScale = new Vector3 (randomScale, randomScale,1);
			newX = newX + gearDistance + Random.Range (randomPosMin.x, randomPosMax.x);

			//Set speed:
			gear.GetComponent<GearController>().normalRotation = gearStartRotationSpeed;
			gearStartRotationSpeed += gearRotationInc;
		}

	}

	IEnumerator ScoreTick() {
		while (isGamePlaying) {
			score++;
			yield return new WaitForSeconds (1f);
			textScore.text = score.ToString ();
		}
	}


	public void DoGameOver() {
		isGamePlaying = false;
		StopCoroutine (ScoreTick());
		if (!gameOverPanel.activeSelf) {
			gameOverPanel.SetActive (true);
		}


	}

	public void ResetScene() {
		SceneManager.LoadScene ("Gameplay");
	}

	public void StartGame() {
		Time.timeScale = 1;
		score = 0;
		textScore.gameObject.SetActive (true);
		isGamePlaying = true;
		StartCoroutine(ScoreTick());
	}
}
