﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GearController : MonoBehaviour {
	public Rigidbody2D rigidbod;
	public float normalRotation;
	public float speedIncreaseOnTouch;
	public float moveSpeedY;


	bool isMouseDown = false;
	float startY;
	float randomRotSpeed;

	// Use this for initialization
	void Start () {
		randomRotSpeed = Random.Range (normalRotation - 20, normalRotation + 20);
		startY = rigidbod.position.y;
	}
	
	// Update is called once per frame
	void Update () {
		float newY;
		if (isMouseDown) {
			newY = rigidbod.position.y + moveSpeedY;
			rigidbod.MovePosition(new Vector2(rigidbod.position.x, newY));
			rigidbod.angularVelocity = randomRotSpeed + speedIncreaseOnTouch;
		}
		else {
			rigidbod.angularVelocity = randomRotSpeed;
			if (rigidbod.position.y > startY) {
				newY = rigidbod.position.y - moveSpeedY;
				rigidbod.MovePosition (new Vector2 (rigidbod.position.x, newY));
			}
		}
	}

	public void Rotate(){
		rigidbod.angularVelocity = -100;
	}

	void OnMouseDown() {
		isMouseDown = true;

	}

	void OnMouseUp() {
		isMouseDown = false;
	}

}
